<?php
/*********************************************************************
    class.resolutions.php

    Resolution Helper

    Scott Brazelton

**********************************************************************/

class Resolution {
    var $id;
 
    var $resolution;
    
    function Resolution($id) {
        $this->id=0;
        $this->load($id);
    }

    function load($id=0) {

        if(!$id && !($id=$this->getId()))
            return false;
			
		$sql='SELECT resolution.* FROM '.TICKET_RESOLUTION_TABLE.' resolution WHERE resolution_id='.db_input($id);
		

        if(!($res=db_query($sql)) || !db_num_rows($res))
            {return false;}

        $this->resolution = db_fetch_array($res);
        $this->id=$this->resolution['resolution_id'];
    
        return true;
    }
  
    function reload() {
        return $this->load();
    }
    
    function getId() {
		
        return $this->id;
    }

    function getName() {
        return $this->resolution['name'];
    }


    function getHashtable() {
        return $this->resolution;
    }

    function getInfo() {
        return $this->getHashtable();
    }

    function update($vars, &$errors) {

        if(!$this->save($this->getId(), $vars, $errors))
            return false;

        $this->reload();
        return true;
    }

    function delete() {

	$total=db_count('SELECT count(*) FROM '.TICKET_TABLE.' ticket WHERE resolution_id ='.db_input($this->getId()));
	
	if ($total >= 1)
	    return false;
	
	$sql='DELETE FROM '.TICKET_RESOLUTION_TABLE.' WHERE resolution_id='.db_input($this->getId()).' LIMIT 1';
        if(db_query($sql) && ($num=db_affected_rows())) {
	    return $num;
        }

        return false;

    }
    /*** Static functions ***/
    function create($vars,&$errors) { 
        return self::save(0, $vars, $errors);
    }

    function getIdByName($name, $id=0) {
	
	    $sql='SELECT resolution_id FROM '.TICKET_RESOLUTION_TABLE
			.' WHERE resolution='.db_input($name);

        if(($res=db_query($sql)) && db_num_rows($res))
            list($id) = db_fetch_row($res);

        return $id;
    }
    function getResolution() {
		
        $resolutions=array();
        $sql='SELECT resolution_id, resolution FROM '.TICKET_RESOLUTION_TABLE;
		$sql.=' WHERE 1 and IsActive = 1';
        if(($res=db_query($sql)) && db_num_rows($res)) {
            while(list($id, $name)=db_fetch_row($res))
                $resolutions[$id] = $name;
        }

        return $resolutions;
    }

    function lookup($id) {
        return ($id && is_numeric($id) && ($t= new Resolution($id)) && $t->getId()==$id)?$t:null;

    }
    
    function save($id, $vars, &$errors) {

        $vars['resolution']=Format::striptags(trim($vars['resolution']));
		$vars['resolution_desc']=Format::striptags(trim($vars['resolution_desc']));

        if($id && $id!=$vars['id'])
            $errors['err']='Internal error. Try again';

        if(!$vars['resolution'])
            $errors['resolution']='Resolution is required';

        elseif(($tid=self::getIdByName($vars['resolution'], $vars['id'])) && $tid!=$id)
            $errors['resolution']='Resolution already exists';
        
        if($errors) return false;
		
		$sql='SELECT resolution_id FROM '.TICKET_RESOLUTION_TABLE
			.' WHERE resolution='.db_input($vars['resolution'])
			.' and resolution_desc='.db_input($vars['resolution_desc'])
			.' and IsActive ='.db_input($vars['IsActive']);
            

		if(($res=db_query($sql)) && db_num_rows($res)){
			$errors['err']='No change detected';
			return false;
		}
		$sql='resolution='.db_input($vars['resolution'])
			.',resolution_desc='.db_input($vars['resolution_desc'])
			.',IsActive='.$vars['IsActive'];
            
        if($id) {
            $sql='UPDATE '.TICKET_RESOLUTION_TABLE.' SET '.$sql.' WHERE resolution_id='.db_input($id);
            if(db_query($sql))
                return true;

            $errors['err']='Unable to update the resolution type. Internal error occured';
        } else {
            $sql='INSERT INTO '.TICKET_RESOLUTION_TABLE.' SET '.$sql;
            if(db_query($sql) && ($id=db_insert_id()))
                return $id;
            
            $errors['err']='Unable to create the resolution type. Internal error occured';
        }
        
        return false;
    }
}
?>
