<?php
/*********************************************************************
    resolutions.php

    Resolutions.

    Scott Brazelton

**********************************************************************/
require('admin.inc.php');
include_once(INCLUDE_DIR.'class.resolutions.php');

$resolution=null;
if($_REQUEST['id'] && !($resolution=Resolution::lookup($_REQUEST['id'])))
    $errors['err']=__('Unknown or invalid resolution ID.');

if($_POST){
    switch(strtolower($_POST['do'])){
        case 'update':
            if(!$resolution){
                $errors['err']=__('Unknown or invalid resolution.');
            }elseif($resolution->update($_POST,$errors)){
                $msg=__('Resolution updated successfully');
            }elseif(!$errors['err']){
                $errors['err']=__('Error updating resolution. Try again!');
            }
            break;
        case 'create':
            if(($id=Resolution::create($_POST,$errors))){
                $msg=__('Resolution added successfully');
                $_REQUEST['a']=null;
            }elseif(!$errors['err']){
                $errors['err']=__('Unable to add resolution. Correct error(s) below and try again.');
            }
            break;
        case 'mass_process':
            switch(strtolower($_POST['a'])) {
            default:
                if(!$_POST['ids'] || !is_array($_POST['ids']) || !count($_POST['ids']))
                    $errors['err'] = sprintf(__('You must select at least %s'),
                        __('one resolution'));
            }
            if (!$errors)
                $count=count($_POST['ids']);
                
            switch(strtolower($_POST['a'])) {
                case 'enable':
                    $sql='UPDATE '.TICKET_RESOLUTION_TABLE.' SET IsActive=1 '
                        .' WHERE resolution_id IN ('.implode(',', db_input($_POST['ids'])).')';

                    if(db_query($sql) && ($num=db_affected_rows())) {
                        if($num==$count)
                            $msg = sprintf(__('Successfully enabled %s'),
                                _N('selected resolution', 'selected resolutions', $count));
                        else
                            $warn = sprintf(__('%1$d of %2$d %3$s enabled'), $num, $count,
                                _N('selected resolution', 'selected resolutions', $count));
                    } else {
                        $errors['err'] = sprintf(__('Unable to enable %s.'),
                            _N('selected resolution', 'selected resolutions', $count))
                            . __('Please ensure not alredy enabled');
                    }
                    break;
                case 'disable':
                    $sql='UPDATE '.TICKET_RESOLUTION_TABLE.' SET isactive=0 '
                        .' WHERE resolution_id IN ('.implode(',', db_input($_POST['ids'])).')';
                    if(db_query($sql) && ($num=db_affected_rows())) {
                        if($num==$count)
                            $msg = sprintf(__('Successfully disabled %s'),
                                _N('selected resolution', 'selected resolutions', $count));
                        else
                            $warn = sprintf(__('%1$d of %2$d %3$s disabled'), $num, $count,
                                _N('selected resolution', 'selected resolutions', $count));
                    } else {
                        $errors['err'] = sprintf(__('Unable to disable %s'),
                            _N('selected resolution', 'selected resolutions', $count))
                            . __('Please ensure not alredy disabled');
                    }
                    break;
                case 'delete':
                    $i=0;
                    foreach($_POST['ids'] as $k=>$v) {
                        if(($res=Resolution::lookup($v)) && $res->delete())
                            $i++;
                    }

                    if($i && $i==$count)
                        $msg = sprintf(__('Successfully deleted %s'),
                            _N('selected resolution', 'selected resolutions', $count));
                    elseif($i>0)
                        $warn = sprintf(__('%1$d of %2$d %3$s deleted'), $i, $count,
                            _N('selected resolution', 'selected resolutions', $count));
                    elseif(!$errors['err'])
                        $errors['err']  = sprintf(__('Unable to delete %s'),
                            _N('selected resolution', 'selected resolutions', $count));
                    break;
                default:
                    $errors['err']=__('Unknown action - get technical help.');
            }
            break;
        default:
            $errors['err']=__('Unknown command/action');
            break;
    }
}

$page='resolutions.inc.php';
if($resolution || ($_REQUEST['a'] && !strcasecmp($_REQUEST['a'],'add')))
    $page='resolution.inc.php';

$nav->setTabActive('manage');
require(STAFFINC_DIR.'header.inc.php');
require(STAFFINC_DIR.$page);
include(STAFFINC_DIR.'footer.inc.php');
?>
